#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;

const long long INF=1e18;

vector<int> Bin(long long x)
{
    vector<int> v;
    while(x>0)
    {
        if(x%2==0)
        {
            v.push_back(0);
        }
        else
        {
            v.push_back(1);
        }

        x/=2;
    }

    return v;
}

long long Tern(vector<int> v)
{
    long long ans=0, p=1;
    for(int i=0; i<v.size() && ans>=0 && p>0; i++)
    {
        ans+=v[i]*p;
        p*=3;
    }

    if(ans==0)
    {
        return 1;
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    long long d;
    cin >> d;

    long long a=d;
    while(a<INF && a>0)
    {
        if(Tern(Bin(a))%d==0)
        {
            vector<int> v=Bin(a);
            for(int i=v.size()-1; i>=0; i--)
            {
                int j;
                for(j=i-1; j>=0 && v[j]==v[i]; j--){}

                if(i-j>1)
                {
                    cout << v[i] << "(" << i-j << ")";
                    i=j+1;
                }
                else
                {
                    cout << v[i];
                }
            }
            cout << "\n";
            return 0;
        }

        a+=d;
    }

    return 0;
}
