#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;
const int MAXN=128;
int a[MAXN];
vector<int> ans;
void CompressArray(int n)
{
    vector<pair<int, int> > v;
    for(int i=0; i<n; i++)
    {
        v.push_back({a[i], i});
    }
    sort(v.begin(), v.end());
    for(int i=0; i<n; i++)
    {
        a[v[i].second]=i;
    }
    return;
}
void MoveFirst(int n, int idx)
{
    int temp[n];

    bool b=false;
    temp[0]=a[idx];
    for(int i=0; i<n; i++)
    {
        if(i==idx)
        {
            b=true;
            continue;
        }
        if(!b)
        {
            temp[i+1]=a[i];
        }
        else
        {
            temp[i]=a[i];
        }
    }

    for(int i=0; i<n; i++)
    {
        a[i]=temp[i];
    }

    return;
}
void SortNumbers(int n)
{
    if(n==1)
    {
        return;
    }

    if(n==2)
    {
        if(a[1]<a[0])
        {
            ans.push_back(2);
            MoveFirst(2, 1);
        }

        return;
    }

    SortNumbers(n/2);

    for(int i=0; i<n/2; i++)
    {
        ans.push_back(n);
        MoveFirst(n, n-1);
    }

    SortNumbers(n/2);

    int cnt=0;
    while(a[n/2-1]>=n/2 && cnt<n/2)
    {
        ans.push_back(n/2);
        MoveFirst(n/2, n/2-1);
        cnt++;
    }

    cnt=0;
    while(a[n-1]>=n/2 && cnt<n/2)
    {
        ans.push_back(n);
        MoveFirst(n, n-1);
        cnt++;
    }

    SortNumbers(n/2);

    for(int i=0; i<n/2; i++)
    {
        ans.push_back(n);
        MoveFirst(n, n-1);
    }

    SortNumbers(n/2);

    return;
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    for(int i=0; i<n; i++)
    {
        cin >> a[i];
    }

    CompressArray(n);
    SortNumbers(n);

    cout << ans.size() << "\n";
    for(int i=0; i<ans.size(); i++)
    {
        cout << ans[i] << " ";
    }
    cout << "\n";

    return 0;
}
