#include <iostream>
#define endl '\n'
using namespace std;

const int MAX = 20000;

int p2[MAX + 5], p3[MAX + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int d;
    cin >> d;

    p2[0] = p3[0] = 1;
    for (int i = 1; i <= 20000; ++ i)
    {
        p2[i] = (1ll * p2[i - 1] * 2) % d;
        p3[i] = (1ll * p3[i - 1] * 3) % d;
    }

    for (int i = 1; ; ++ i)
    {
        int j = i, x = 0, q2 = 0, q3 = 0;
        string s = "";
        while (j)
        {
            s = char(j % 2 + '0') + s;
            if (j % 2)
            {
                q2 = (q2 + p2[x]) % d;
                q3 = (q3 + p3[x]) % d;
            }
            x++;
            j /= 2;
        }
        if (q2 == q3 and q2 == 0)
        {
            cout << s << endl;
            break;
        }
    }

    return 0;
}
