#include <iostream>
#include <string>
#include <map>
#define endl '\n'
using namespace std;

const int MAXN = 1000;
const int MAXS = 500000;

int n;
map< pair<int, string>, int > mp;
int a[MAXN + 5], b[MAXN + 5];

int rec(int s, string str)
{
    if (s == 0) return 0;
    if (mp.count(make_pair(s, str)) != 0) return mp[make_pair(s, str)];
    int ans = 2 * MAXS + 1;
    for (int i = 1; i <= n; ++ i)
    {
        if (str[i] == '1') continue;
        str[i] = '1';
        ans = min(ans, max(s, rec(s - a[i], str)) + b[i]);
        str[i] = '0';
    }
    mp[make_pair(s, str)] = ans;
    return ans;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;

    int s = 0;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        s += a[i];
    }

    for (int i = 1; i <= n; ++ i)
    {
        cin >> b[i];
    }

    string str(n + 1, '0');

    cout << rec(s, str) << endl;

    return 0;
}
