#include <iostream>
#include <utility>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;

const int MAXN = 1000;
const int INF = 1000000000;

int n;
bool used[MAXN + 5];
int a[MAXN + 5], b[MAXN + 5];
vector< pair<int, int> > G[MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
    }

    for (int i = 1; i <= n; ++ i)
    {
        cin >> b[i];
    }

    int s = 0;
    for (int i = 1; i <= n; ++ i)
    {
        if (i > 1) s += (a[i] > b[i - 1] ? a[i] - b[i - 1] : 0);
        else s += a[i];
        s += b[i];
    }

    for (int i = n; i >= 1; -- i)
    {
        bool flag;
        do
        {
            flag = false;
            for (int j = i - 1; j >= 1; -- j)
            {
                int s1 = s;
                if (i > 1) s1 -= (a[i] > b[i - 1] ? a[i] - b[i - 1] : 0);
                else s1 -= a[i];
                s1 -= b[i];
                if (i < n) s1 -= (a[i + 1] > b[i] ? a[i + 1] - b[i] : 0);

                if (j > 1) s1 -= (a[j] > b[j - 1] ? a[j] - b[j - 1] : 0);
                else s1 -= a[j];
                s1 -= b[j];
                if (j < n) s1 -= (a[j + 1] > b[j] ? a[j + 1] - b[j] : 0);

                if (i > 1) s1 += (a[j] > b[i - 1] ? a[j] - b[i - 1] : 0);
                else s1 += a[j];
                s1 += b[j];
                if (i < n) s1 += (a[i + 1] > b[j] ? a[i + 1] - b[j] : 0);

                if (j > 1) s1 += (a[i] > b[j - 1] ? a[i] - b[j - 1] : 0);
                else s1 += a[i];
                s1 += b[i];
                if (j < n) s1 += (a[j + 1] > b[i] ? a[j + 1] - b[i] : 0);

                if (s1 < s)
                {
                    s = s1;
                    swap(a[i], a[j]);
                    swap(b[i], b[j]);
                    flag = true;
                    break;
                }
            }
        } while (flag);
    }

    cout << s << endl;

    return 0;
}
