#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 128;

int n;
int a[MAXN + 5];
int p[MAXN + 5];
vector<int> ops, v;
vector< pair<int, int> > s;

void sort_halves(int start, int n)
{
    if (n == 2)
    {
        if (a[start] > a[start + 1])
        {
            ops.push_back(2);
        }
        return;
    }

    sort_halves(start, n / 2);
    for (int i = 1; i <= n / 2; ++ i)
    {
        ops.push_back(n);
    }
    sort_halves(start + n / 2, n / 2);
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        s.push_back(make_pair(a[i], i));
    }

    sort(s.begin(), s.end());

    for (int i = 0; i < n; ++ i)
    {
        p[s[i].second] = i + 1;
    }

    sort_halves(1, n);

    sort(a + 1, a + n / 2 + 1);
    sort(a + n / 2 + 1, a + n + 1);

    v.push_back(0);
    for (int i = n / 2 + 1; i <= n; ++ i)
    {
        if (p[i] > n / 2)
        {
            ops.push_back(n / 2);
        }
    }

    for (int i = 1; i <= n / 2; ++ i)
    {
        if (p[i] > n / 2)
        {
            ops.push_back(n);
        }
    }

    for (int i = 1; i <= n / 2; ++ i)
    {
        if (p[i] > n / 2)
        {
            v.push_back(a[i]);
        }
    }

    for (int i = n / 2 + 1; i <= n; ++ i)
    {
        if (p[i] > n / 2)
        {
            v.push_back(a[i]);
        }
    }

    for (int i = n / 2 + 1; i <= n; ++ i)
    {
        if (p[i] <= n / 2)
        {
            v.push_back(a[i]);
        }
    }

    for (int i = 1; i <= n / 2; ++ i)
    {
        if (p[i] <= n / 2)
        {
            v.push_back(a[i]);
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        a[i] = v[i];
    }

    sort_halves(1, n);

    cout << ops.size() << endl;
    for (int i = 0; i < ops.size(); ++ i)
    {
        cout << ops[i] << " ";
    }
    cout << endl;

    return 0;
}
