#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 128;

int n;
int a[MAXN + 5];
vector<int> ops;
vector< pair<int, int> > v;

void sort_by_halves(int start, int n)
{
    if (n == 2)
    {
        if (a[start] > a[start + 1])
        {
            ops.push_back(2);
            swap(a[start], a[start + 1]);
        }
        return;
    }

    sort_by_halves(start, n / 2);
    for (int i = 1; i <= n / 2; ++ i)
    {
        ops.push_back(n);
    }
    sort_by_halves(start + n / 2, n / 2);

    reverse(a + start, a + start + n);
    sort(a + start, a + start + n / 2);
    sort(a + start + n / 2, a + start + n);

    vector<int> s;
    for (int i = start; i < start + n; ++ i)
    {
        s.push_back(a[i]);
    }
    sort(s.begin(), s.end());

    for (int i = start; i < start + n / 2; ++ i)
    {
        if (a[i] >= s[n / 2])
        {
            ops.push_back(n / 2);
        }
    }

    for (int i = start + n / 2; i < start + n; ++ i)
    {
        if (a[i] >= s[n / 2])
        {
            ops.push_back(n);
        }
    }

    vector<int> t;
    for (int i = start + n / 2; i < start + n; ++ i)
    {
        if (a[i] >= s[n / 2])
        {
            t.push_back(a[i]);
        }
    }

    for (int i = start; i < start + n / 2; ++ i)
    {
        if (a[i] >= s[n / 2])
        {
            t.push_back(a[i]);
        }
    }

    for (int i = start; i < start + n; ++ i)
    {
        if (a[i] < s[n / 2])
        {
            t.push_back(a[i]);
        }
    }

    for (int i = start; i < start + n; ++ i)
    {
        a[i] = t[i - start];
    }

    sort_by_halves(start, n / 2);
    for (int i = 1; i <= n / 2; ++ i)
    {
        ops.push_back(n);
    }
    sort_by_halves(start + n / 2, n / 2);
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        v.push_back(make_pair(a[i], i));
    }

    sort(v.begin(), v.end());

    for (int i = 0; i < n; ++ i)
    {
        a[v[i].second] = i + 1;
    }

    sort_by_halves(1, n);

    cout << ops.size() << endl;
    for (int i = 0; i < ops.size(); ++ i)
    {
        cout << ops[i] << " ";
    }
    cout << endl;

    return 0;
}
