#include<iostream>
#include<vector>
#include<queue>
#include<algorithm>
#include<math.h>
#include<stack>

using namespace std;

const int binSize = 10000;

bool testIt(long long n, long long d)
{
    bool bin[binSize];
    int len = 0;

    do
    {
        bin[len] = n % 2 == 1;
        n /= 2;
        len++;
    }
    while(n != 0);

    n = 0;
    long long p = 1;

    for(int i = 0;i < len;i++)
    {
        ///cout<<bin[i]<<" ";
        n += p * bin[i];
        p *= 3;
    }
    ///cout<<endl;

    if(n % d == 0)
    {
        cout<<n<<endl;
        if(len >= 10000)
        {
            int streak = 1;

            cout<<bin[len - 1];
            for(int i = len - 1;i >= 1;i--)
            {
                if(bin[i] != bin[i - 1])
                {
                    if(streak > 1)
                    {
                        cout<<"("<<streak<<")";
                    }
                    cout<<bin[i - 1];
                    streak = 1;
                }
                else
                {
                    streak++;
                }
            }

            if(bin[0] == bin[1])
            {
                cout<<"("<<streak<<")";
            }

            cout<<endl;
        }
        else
        {
            for(int i = len - 1;i >= 0;i--)
            {
                cout<<bin[i];
            }
            cout<<endl;
        }
        return true;
    }

    return false;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    long long d;

    cin>>d;

    long long n = 1;

    while(true)
    {
        if(testIt(n * d, d))
        {
            cout<<n * d<<endl;
            break;
        }
        n++;
    }
}
