#include<iostream>
#include<vector>
#include<queue>
#include<algorithm>
#include<math.h>
#include<stack>

using namespace std;

int a[130];
int n;
int iterations = 0;

stack<int> moves;

bool found = false;

bool sorted()
{
    for(int i = 0;i < n - 1;i++)
    {
        if(a[i] > a[i + 1])
        {
            return false;
        }
    }

    stack<int> moves2 = moves;

    int rez[moves2.size()];

    int p = 0;

    cout<<moves2.size()<<endl;

    while(!moves2.empty())
    {
        rez[p] = moves2.top();
        moves2.pop();
        p++;
    }

    if(moves.size() == 0)
    {
        found = true;
        return true;
    }

    for(int i = moves.size() - 1;i >= 1;i--)
    {
        cout<<rez[i]<<" ";
    }

    cout<<rez[0]<<endl;

    found = true;

    return true;
}

void recursion()
{
    sorted();

    if(found)
    {
        return;
    }

    if(iterations > 15)
    {
        return;
    }

    for(int i = n; i >= 2;i /= 2)
    {
        int selected = a[i - 1];

        iterations++;

        for(int j = i - 1;j >= 0;j--)
        {
            a[j] = a[j - 1];
        }

        a[0] = selected;

        moves.push(i);

        recursion();

        for(int j = 0;j < i;j++)
        {
            a[j] = a[j + 1];
        }

        a[i - 1] = selected;

        iterations--;

        moves.pop();
    }

    return;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>n;

    int ones = 0;
    int twos = 0;

    for(int i = 0;i < n;i++)
    {
        cin>>a[i];

        if(a[i] == 1)
        {
            ones++;
        }
        if(a[i] == 2)
        {
            twos++;
        }
    }

    if(ones + twos == n && ones == twos)
    {
        do
        {
            bool oneFound = false;
            for(int i = 2;i <= n;i *= 2)
            {
                if(a[i - 1] == 1)
                {
                    if(i == 2 && a[0] == 1)
                    {
                        continue;
                    }

                    int selected = a[i - 1];

                    for(int j = i - 1;j >= 0;j--)
                    {
                        a[j] = a[j - 1];
                    }

                    a[0] = selected;

                    moves.push(i);

                    oneFound = true;

                    break;
                }
            }
            if(oneFound == false)
            {
                int i = n;
                int selected = a[i - 1];

                for(int j = i - 1;j >= 0;j--)
                {
                    a[j] = a[j - 1];
                }

                a[0] = selected;
                oneFound = true;

                moves.push(i);
            }
        }
        while(!sorted());

        return 0;
    }

    recursion();
}
