#include<iostream>
#include<algorithm>
using namespace std;

int broiDetaili;

struct DanniZaDetail{
    int parvaMashinaVreme;
    int vtoraMashinaVreme;
};

DanniZaDetail detaili[1010];

int otgovor;

bool toziIzpolzvaLiSe[1010];

void nameriOtgovor(int broiVzeti, int vremeParvaOpashka, int vremeVtoraOpashka){
    if(broiVzeti == broiDetaili){
        if(vremeVtoraOpashka < otgovor || otgovor == 0){
            otgovor = vremeVtoraOpashka;
        }

        return ;
    }

    for(int i = 0; i < broiDetaili; i++){
        if(toziIzpolzvaLiSe[i] == false){
            toziIzpolzvaLiSe[i] = true;

            int novoParvaVreme = vremeParvaOpashka + detaili[i].parvaMashinaVreme;
            int novoVtoraVreme = max(vremeVtoraOpashka, novoParvaVreme) + detaili[i].vtoraMashinaVreme;

            nameriOtgovor(broiVzeti + 1, novoParvaVreme, novoVtoraVreme);

            toziIzpolzvaLiSe[i] = false;
        }
    }
}

bool poNapredLiE(DanniZaDetail a, DanniZaDetail b){
    if(a.vtoraMashinaVreme > b.vtoraMashinaVreme){
        return true;
    }else{
        if(a.vtoraMashinaVreme < b.vtoraMashinaVreme){
            return false;
        }else{
            return a.parvaMashinaVreme > b.parvaMashinaVreme;
        }
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>broiDetaili;

    for(int i = 0; i < broiDetaili; i++){
        cin>>detaili[i].parvaMashinaVreme;
    }

    for(int i = 0; i < broiDetaili; i++){
        cin>>detaili[i].vtoraMashinaVreme;
    }

    //nameriOtgovor(0, 0, 0);

    sort(detaili, detaili + broiDetaili, poNapredLiE);

    int parvaMashina = 0;
    int vtoraMashina = 0;

    for(int i = 0; i < broiDetaili; i++){
        parvaMashina += detaili[i].parvaMashinaVreme;

        vtoraMashina = max(vtoraMashina, parvaMashina) + detaili[i].vtoraMashinaVreme;
    }

    otgovor = vtoraMashina;

    cout<<otgovor<<endl;

    return 0;
}
