#include<bits/stdc++.h>
#define endl "\n"
#pragma GCC optimize ("-O3")

using namespace std;

struct edge
{
    long long x, y;
    edge() { }
    edge(int x, int y) :x(x), y(y) { }
    bool operator< (const edge &o) const
    {
        return x-y+x>o.x-o.y+o.x;
    }
};

struct mark
{
    int id, d1, d2;
    mark() { }
    mark(int id, int d1, int d2) :id(id), d1(d1), d2(d2) { }
};

const int nmax=1024, inf=1e9;
long long t[nmax], b[nmax];
mark v[nmax];
edge a[nmax];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    long long n, ans, a1, a2, pos;
    cin>>n;
    for(int i=1; i<=n; ++i) cin>>a[i].x;
    for(int i=1; i<=n; ++i) cin>>a[i].y;
    sort(a+1, a+n+1);

    v[1]={1, a[1].x, a[1].x+a[1].y};
    for(int i=2; i<=n; ++i)
    {
        ans=inf;
        for(int j=1; j<=i; ++j)
        {
            a1=0, a2=0;
            a1=v[j-1].d1;
            a2=v[j-1].d2;
            for(int k=j; k<=i; ++k)
            {
                if(k==j) a1+=a[i].x, a2=max(a1+a[i].y, a2+a[i].y);
                a1+=a[v[k].id].x;
                a2=max(a1+a[v[k].id].y, a2+a[v[k].id].y);
            }
            if(max(a1, a2)<ans) ans=max(a1, a2), pos=j;
        }
        for(int j=i; j>=1; --j)
        {
            if(pos<=j) v[j+1].id=v[j].id;
            if(j==pos) v[j].id=i;
        }
        for(int j=1; j<=i; ++j) v[j].d1=v[j-1].d1+a[v[j].id].x, v[j].d2=max(v[j].d1+a[v[j].id].y, v[j].d2+a[v[j].id].y);
    }
    a1=0, a2=0;
    for(int i=1; i<=n; ++i)
    {
        a1+=a[v[i].id].x;
        a2=max(a1+a[v[i].id].y, a2+a[v[i].id].y);
    }
    cout<<max(a1, a2)<< endl;
    return 0;
}
