#include<iostream>
using namespace std;

const int MAXN=1e3, INF=1e9;

int a[MAXN], b[MAXN], dp[MAXN][MAXN];
bool v[MAXN];

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    for(int i=0; i<n; i++)
    {
        cin >> a[i];
    }

    for(int i=0; i<n; i++)
    {
        cin >> b[i];
    }

    if(n==1)
    {
        cout << a[0]+b[0] << "\n";

        return 0;
    }

    int min1=0, min2=1;
    for(int i=0; i<n; i++)
    {
        v[i]=false;

        for(int j=0; j<n; j++)
        {
            if(i==j)
            {
                dp[i][j]=INF;
                continue;
            }

            dp[i][j]=a[i]+abs(a[j]-b[i]);

            if(dp[i][j]<dp[min1][min2])
            {
                min1=i, min2=j;
            }
        }
    }

    v[min1]=true, v[min2]=true;

    long long ans=a[min1]+max(b[min1], a[min2])+b[min2];
    int vc=2;
    min1=min2;
    while(vc<n)
    {
        int min2=-1;
        for(int i=0; i<n; i++)
        {
            if(min1==i || v[i])
            {
                continue;
            }

            if(min2==-1 || dp[min1][min2]>dp[min1][i])
            {
                min2=i;
            }
        }

        ans+=max(a[min2]-b[min1], 0)+b[min2];
        v[min2]=true, vc++, min1=min2;
    }

    cout << ans << "\n";

    return 0;
}
