#include<iostream>
using namespace std;

const int MAXN=1e3, INF=1e9;

int a[MAXN], b[MAXN];
long long ans=INF;
bool v[MAXN];

void GetMinTime(int n, int idx, int ai, int bi, int t)
{
    if(t>ans)
    {
        return;
    }

    if(idx==n)
    {
        ans=t;
    }

    for(int i=0; i<n; i++)
    {
        if(!v[i])
        {
            v[i]=true;

            GetMinTime(n, idx+1, a[i], b[i], t+max(0, a[i]-bi)+b[i]);

            v[i]=false;
        }
    }

    return;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    for(int i=0; i<n; i++)
    {
        v[i]=false;

        cin >> a[i];
    }

    for(int i=0; i<n; i++)
    {
        cin >> b[i];
    }

    for(int i=0; i<n; i++)
    {
        v[i]=true;

        GetMinTime(n, 1, a[i], b[i], a[i]+b[i]);

        v[i]=false;
    }

    cout << ans << "\n";

    return 0;
}
