#include <iostream>
#include <set>
#define endl '\n'
using namespace std;

const int MAX = 20000;

int p2[MAX + 5], p3[MAX + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int d;
    cin >> d;

    if (d < 7000)
    {
        p2[0] = p3[0] = 1;
        for (int i = 1; i <= MAX; ++ i)
        {
            p2[i] = (1ll * p2[i - 1] * 2) % d;
            p3[i] = (1ll * p3[i - 1] * 3) % d;
        }

        for (int i = 1; ; ++ i)
        {
            int j = i, x = 0, q2 = 0, q3 = 0;
            string s = "";
            while (j)
            {
                s = char(j % 2 + '0') + s;
                if (j % 2)
                {
                    q2 = (q2 + p2[x]) % d;
                    q3 = (q3 + p3[x]) % d;
                }
                x++;
                j /= 2;
            }
            if (q2 == q3 and q2 == 0)
            {
                cout << s << endl;
                break;
            }
        }

        return 0;
    }

    p2[0] = p3[0] = 1;
    int i0, j0;
    for (int i = 1; i <= MAX; ++ i)
    {
        p2[i] = (1ll * p2[i - 1] * 2) % d;
        p3[i] = (1ll * p3[i - 1] * 3) % d;
        for (int j = 0; j < i; ++ j)
        {
            if ((p2[i] + p2[j]) % d == 0 and (p3[i] + p3[j]) % d == 0)
            {
                i0 = i;
                j0 = j;
                break;
            }
        }
    }

    cout << 1;
    if (i0 - j0 - 1 == 0) {}
    else if (i0 - j0 - 1 == 1) cout << 0;
    else if (i0 - j0 - 1 == 2) cout << "00";
    else cout << "0(" << i0 - j0 - 1 << ")";
    cout << 1;
    if (j0 == 0) {}
    else if (j0 == 1) cout << 0;
    else if (j0 == 2) cout << "00";
    else cout << "0(" << j0 << ")";
    cout << endl;

    return 0;
}
