#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 1000;

int a[MAXN + 5], b[MAXN + 5];

bool cmp(pair<int, int> a, pair<int, int> b)
{
    if (a.second != b.second) return a.second > b.second;
    return a.first < b.first;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
    }

    vector< pair<int, int> > v;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> b[i];
        v.push_back(make_pair(a[i], b[i]));
    }

    sort(v.begin(), v.end(), cmp);

    int s = 0;
    for (int i = 0; i < n; ++ i)
    {
        if (i > 0) s += (v[i].first > v[i - 1].second ? v[i].first - v[i - 1].second : 0);
        else s += v[i].first;
        s += v[i].second;
    }

    cout << s << endl;

    return 0;
}
