#include <iostream>
#include <utility>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;

const int MAXN = 1000;
const int INF = 1000000000;

int n;
bool used[MAXN + 5];
int a[MAXN + 5], b[MAXN + 5];
vector< pair<int, int> > G[MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
    }

    for (int i = 1; i <= n; ++ i)
    {
        cin >> b[i];
    }

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= n; ++ j)
        {
            if (i != j)
            {
                int w = b[i] - a[j];
                if (w < 0) w = 0;
                G[i].push_back(make_pair(j, w));
            }
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        G[0].push_back(make_pair(i, a[i]));
        G[i].push_back(make_pair(n + 1, b[i]));
    }

    int u = 0, cnt = 0, s = 0, p = 0;
    while (cnt < n + 1)
    {
        used[u] = true;
        int ss = INF, uu = 0;
        for (int i = 0; i < G[u].size(); ++ i)
        {
            int v = G[u][i].first, w = G[u][i].second;
            if (!used[v] and ((cnt < n and v != n + 1) or cnt == n))
            {
                if (w < ss)
                {
                    ss = w;
                    uu = v;
                }
            }
        }
        if (p != 0) s += a[u];
        s += ss;
        p = u;
        u = uu;
        cnt++;
    }

    cout << s << endl;

    return 0;
}
