#include<bits/stdc++.h>
#define endl '\n'
#define space ' '
#define ii pair<int, int>
#define ff first
#define ss second
using namespace std;

const int MAXN = (1<<7)+10;

int n;
ii data[MAXN];
deque<int> pars(MAXN);
vector<int> answ;

void TPrint()
{
    for(int i = 0; i < n; i++)
        cout << pars[i] << space;
    cout << endl;
}

void InputProcess()
{
    cin >> n;
    for(int i = 0; i < n; i++)
    {
        cin >> data[i].ff; data[i].ss = i;
    }
    sort(data, data+n);
    for(int i = 0; i < n; i++)
    {
        pars[data[i].ss] = i+1;
    }
}

void Rotate(deque<int> &toRotate, int fromPosition)
{
    toRotate.push_front( toRotate[fromPosition-1] );
    toRotate.erase(toRotate.begin()+fromPosition);
    answ.push_back(fromPosition);
}

void Reverse(deque<int> &toReverse, int fromPosition)
{
    for(int i = fromPosition/2; i > 0; i--)
        Rotate(toReverse, fromPosition);
}

void Organise(deque<int> &toOrganise, int bigRotPos)
{
    if(bigRotPos == 2)
    {
        if(toOrganise[1]<toOrganise[0])
            Rotate(toOrganise, 2);
        return;
    }

    int zeros = 0, middleValue = 0;
    int smallRotPos = bigRotPos/2;

    for(int i = 0; i < bigRotPos; i++)
        middleValue += toOrganise[i];
    middleValue /= bigRotPos;

    for(int i = smallRotPos; i < bigRotPos; i++)
        if(toOrganise[i] <= middleValue) zeros++;

    while(zeros != 0)
    {
        while(toOrganise[smallRotPos-1] <= middleValue)
            Rotate(toOrganise, smallRotPos);
        if(toOrganise[bigRotPos-1] <= middleValue)
            zeros--;
        Rotate(toOrganise, bigRotPos);
    }
}

void Sort(deque<int> &toSort, int backEnd)
{
    if(backEnd==1) return;
    Organise(toSort, backEnd);
    Sort(toSort, backEnd/2);
    Reverse(toSort, backEnd);
    Sort(toSort, backEnd/2);
    Reverse(toSort, backEnd);
}

void Solve()
{
    Sort(pars, n);
    //TPrint();
    int siz = answ.size();
    cout << siz << endl;
    for(int i = 0; i < siz; i++)
        cout << answ[i] << space;
    cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    InputProcess();
    Solve();
    return 0;
}
/*
8
8 1 3 7 4 5 2 6
16
16 15 14 13 12 11 10 9 8 7 6 5 4 3 2 1
16
16 5 14 9 12 11 1 13 8 2 6 15 4 3 7 10
*/
