#include<iostream>
#include<vector>
#include<queue>
#include<algorithm>
#include<math.h>
#include<stack>

using namespace std;

int a[130];
int n;
int iterations = 0;

stack<int> moves;

bool found = false;

bool sorted()
{
    for(int i = 0;i < n - 1;i++)
    {
        if(a[i] > a[i + 1])
        {
            return false;
        }
    }

    stack<int> moves2 = moves;

    int rez[moves2.size()];

    int p = 0;

    cout<<moves2.size()<<endl;

    while(!moves2.empty())
    {
        rez[p] = moves2.top();
        moves2.pop();
        p++;
    }

    if(moves.size() == 0)
    {
        found = true;
        return true;
    }

    for(int i = moves.size() - 1;i >= 1;i--)
    {
        cout<<rez[i]<<" ";
    }

    cout<<rez[0]<<endl;

    found = true;

    return true;
}

void swapNums(int num)
{
    int indx = 0;

    int minN = n;

    for(int i = 0;i < n;i++)
    {
        if(a[i] == num)
        {
            indx = i;
            break;
        }
    }

    for(int i = minN;i >= 4;i /= 2)
    {
        if(indx >= i)
        {
            break;
        }
        minN = i;
    }

    while(a[1] != num)
    {
        moves.push(minN);
        int i = minN;
        int selected = a[i - 1];

        for(int j = i - 1;j >= 0;j--)
        {
            a[j] = a[j - 1];
        }

        a[0] = selected;
    }

    for(int i = 0;i < indx - num + 1;i++)
    {
        int m = 2;
        moves.push(m);
        int selected = a[m - 1];

        for(int j = m - 1;j >= 0;j--)
        {
            a[j] = a[j - 1];
        }

        a[0] = selected;

        m = minN;
        moves.push(m);
        selected = a[m - 1];

        for(int j = m - 1;j >= 0;j--)
        {
            a[j] = a[j - 1];
        }

        a[0] = selected;
    }

    while(a[0] != 1)
    {
        int i = minN;

        int selected = a[i - 1];

        for(int j = i - 1;j >= 0;j--)
        {
            a[j] = a[j - 1];
        }

        a[0] = selected;

        moves.push(minN);
    }
}

void recursion()
{

    while(a[0] != 1)
    {
        int i = n;

        int selected = a[i - 1];

        for(int j = i - 1;j >= 0;j--)
        {
            a[j] = a[j - 1];
        }

        a[0] = selected;

        moves.push(n);
    }

    for(int i = 2;i <= n;i++)
    {
        swapNums(i);
    }

    return;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>n;

    int a2[n];

    int ones = 0;
    int twos = 0;

    for(int i = 0;i < n;i++)
    {
        cin>>a[i];
        a2[i] = a[i];

        if(a[i] == 1)
        {
            ones++;
        }
        if(a[i] == 2)
        {
            twos++;
        }
    }

    if(ones + twos == n && ones == twos)
    {
        do
        {
            bool oneFound = false;
            for(int i = 2;i <= n;i *= 2)
            {
                if(a[i - 1] == 1)
                {
                    bool twoFound = false;
                    for(int j = 0;j < i;j++)
                    {
                        if(a[j] == 2)
                        {
                            twoFound = true;
                        }
                    }

                    if(!twoFound)
                    {
                        continue;
                    }

                    int selected = a[i - 1];

                    for(int j = i - 1;j >= 0;j--)
                    {
                        a[j] = a[j - 1];
                    }

                    a[0] = selected;

                    moves.push(i);

                    oneFound = true;

                    break;
                }
            }
            if(oneFound == false)
            {
                int i = n;
                int selected = a[i - 1];

                for(int j = i - 1;j >= 0;j--)
                {
                    a[j] = a[j - 1];
                }

                a[0] = selected;
                oneFound = true;

                moves.push(i);
            }
        }
        while(!sorted());

        return 0;
    }

    sort(a2, a2 + n);

    for(int i = 0;i < n;i++)
    {
        for(int j = 0;j < n;j++)
        {
            if(a2[i] == a[j])
            {
                a[j] = i + 1;
                break;
            }
        }
    }

    recursion();

    sorted();
}
/*
8
1 2 5 7 4 8 3 6
*/
