#include <iostream>
#include <vector>
#include <unordered_set>
#include <algorithm>
#include <cassert>
using namespace std;
#define endl '\n'
#define int long long
#define MAXN 150
#define uset unordered_set
int br;
int arr[MAXN];
uset<int> power;
vector<int> ans;
int copi[MAXN];
void execute(int pos)
{
    if(pos == 1) return;
    ans.push_back(pos);
    for(int i = 1; i <= br; ++i){
        copi[i] = arr[i];
    }
    for(int i = 2; i <= pos; ++i){
        arr[i] = copi[i - 1];
    }
    arr[1] = copi[pos];
}
vector<pair<int, int> > v;
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> br;
    for(int i = 1; i <= br; i *= 2){
        power.insert(i);
    }
    for(int i = 1; i <= br; ++i){
        cin >> arr[i];
        v.push_back({arr[i], i});
    }
    sort(v.begin(), v.end());
    int cnt = 1;
    for(pair<int, int> p : v){
        arr[p.second] = cnt;
        ++cnt;
    }
    while(true){
        int pos;
        for(int i = 1; i <= br; ++i){
            if(arr[i] == br){
                pos = i; break;
            }
        }
        //cout << pos << endl;
        if(power.find(pos) != power.end()){
            execute(pos); break;
        }
        execute(br);
    }
    //cout << "here\n";
    for(int i = br - 1; i >= 1; --i){
        int poscur, posnext;
        for(int z = 1; z <= br; ++z){
            if(arr[z] == i) poscur = z;
            if(arr[z] == i + 1) posnext = z;
        }
        //cout << "a\n";
        if(poscur > posnext){
            while(power.find(poscur) == power.end()){
                execute(br);
                ++poscur; ++posnext;
            }
            execute(poscur); poscur = 1; posnext++;
        }
        //cout << "b\n";
        int want = posnext - 1;
        if(want == poscur) continue;
        while(power.find(want) == power.end()){
            execute(br);
            ++poscur; ++want; ++posnext;
            if(posnext > br) posnext = 1;
        }
        //cout << "c\n";
        while(poscur != want){
            execute(want);
            ++poscur;
        }
        //cout << "d\n";
        int poslast;
        for(int z = 1; z <= br; ++z){
            if(arr[z] == br) poslast = z;
        }
        while(poslast < poscur){
            execute(br);
            ++poslast; ++poscur;
            if(poscur > br) poscur = 1;
        }
    }
    if(ans.size() > br * br) assert(false);
    cout << ans.size() << endl;
    for(int i : ans){
        cout << i << ' ';
    }
    cout << endl;
    return 0;
}
