#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>
using namespace std;
#define endl '\n'
#define int long long
int br;
unordered_set<int> u;
vector<pair<int, int> > v;
int enhash(vector<int> ve)
{
    int res = 0;
    int base = 10;
    for(int i = 0; i < ve.size(); ++i){
        res *= base; res += ve[i];
    }
    return res;
}
bool sorted(vector<int> d)
{
    for(int i = 1; i < d.size(); ++i){
        if(d[i] < d[i - 1]) return false;
    }
    return true;
}
vector<int> st;
int cop[15];
bool execute(vector<int>& where, int pos)
{
    for(int i = 0; i < where.size(); ++i){
        cop[i] = where[i];
    }
    for(int i = 1; i <= pos; ++i){
        where[i] = cop[i - 1];
    }
    where[0] = cop[pos];
}
void recurse(vector<int> ve)
{
    int h = enhash(ve);
    if(u.find(h) != u.end()) return;
    u.insert(h);
    if(sorted(ve)){
        cout << st.size() << endl;
        for(int i : st){
            cout << i + 1 << ' ';
        }
        cout << endl; exit(0);
    }
    for(int i = 2; i <= ve.size(); ++i){
        vector<int> copi = ve;
        execute(ve, i - 1);
        st.push_back(i - 1);
        recurse(ve);
        ve = copi;
    }
}
vector<int> arr;
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> br; arr.resize(br);
    for(int i = 0; i < br; ++i){
        cin >> arr[i];
        v.push_back({arr[i], i});
    }
    sort(v.begin(), v.end());
    int cnt = 1;
    for(pair<int, int> p : v){
        arr[p.second] = cnt;
        ++cnt;
    }
    recurse(arr);
    return 0;
}
