#include<bits/stdc++.h>
#define endl "\n"

using namespace std;

struct edge
{
    long long x, y;
    edge() { }
    edge(int x, int y) :x(x), y(y) { }
    bool operator< (const edge &o) const
    {
        return y-x>o.y-o.x;
    }
};

const int nmax=1024, inf=1e9;
long long t[nmax], b[nmax], v[nmax];
edge a[nmax];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    long long n, ans, a1, a2, pos;
    cin>>n;
    for(int i=1; i<=n; ++i) cin>>a[i].x;
    for(int i=1; i<=n; ++i) cin>>a[i].y;
    sort(a+1, a+n+1);

    v[1]=1;
    for(int i=2; i<=n; ++i)
    {
        ans=inf;
        for(int j=1; j<=i; ++j)
        {
            a1=0, a2=0;
            for(int k=1; k<=i; ++k)
            {
                if(k==j) a1+=a[i].x, a2=max(a1+a[i].y, a2+a[i].y);
                a1+=a[v[k]].x;
                a2=max(a1+a[v[k]].y, a2+a[v[k]].y);
            }
            if(max(a1, a2)<ans) ans=max(a1, a2), pos=j;
        }
        for(int j=i; j>=1; --j)
        {
            if(pos<=j) v[j+1]=v[j];
            if(j==pos) v[j]=i;
        }
    }
    a1=0, a2=0;
    for(int i=1; i<=n; ++i)
    {
        a1+=a[v[i]].x;
        a2=max(a1+a[v[i]].y, a2+a[v[i]].y);
    }
    cout<<max(a1, a2)<< endl;
    return 0;
}
